/**
 * Copyright (C) 2010 Cloudfarming <info@cloudfarming.nl>
 *
 * Licensed under the Eclipse Public License - v 1.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *         http://www.eclipse.org/legal/epl-v10.html
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package nl.cloudfarming.client.sensor.area;

import java.util.ArrayList;
import java.util.List;
import nl.cloudfarming.client.geoviewer.Category;
import nl.cloudfarming.client.geoviewer.Layer;
import nl.cloudfarming.client.model.Plot;
import nl.cloudfarming.client.model.SensorData;
import nl.cloudfarming.client.sensor.SensorPalette;
import org.openide.util.NbBundle;

/**
 *
 * @author Timon Veenstra
 */
public class AreaSensorDataLayer extends Layer<AreaSensorDataLayerObject> {

    public AreaSensorDataLayer(AreaSensorDataLayerObject.KeyAttribute keyAttribute) {
        super(SensorPalette.PALLET01_04, Category.SENSOR, NbBundle.getMessage(AreaSensorDataLayer.class, "layer.name.sensor.area", keyAttribute));
        if (getObjects().size() > 0) {
            clearObjects();
        }

        List<AreaSensorDataLayerObject> objects = new ArrayList<AreaSensorDataLayerObject>();

        SensorAreaService service = new SensorAreaService();
        for (Plot plot : service.findAllPlots()) {
            List<SensorData> sensorData = service.findSensorDataForPlot(plot);
            objects.add(new AreaSensorDataLayerObject(plot, sensorData));
        }
        addObjects(objects);
    }
}
